<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="库存地点" prop="storageLocationId">
        <el-select v-model="formData.storageLocationId" clearable placeholder="请选择">
          <el-option
            v-for="item in storageLocationList"
            :key="item.id"
            :label="item.storageLocationName"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="库区编码" prop="code">
        <el-input v-model="formData.code" placeholder="请输入库区编码" />
      </el-form-item>
      <el-form-item label="库区名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入库区名称" />
      </el-form-item>
      <el-form-item label="显示排序" prop="sort">
        <el-input-number v-model="formData.sort" :min="0" controls-position="right" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import {IotStorageAreaApi, IotStorageAreaVO} from '@/api/pms/iotstoragearea'
import * as SapOrgApi from "@/api/system/saporg";
import {FormRules} from 'element-plus'

/** PMS 库区 表单 */
defineOptions({ name: 'IotStorageAreaForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改

const storageLocationList = ref([] as SapOrgApi.SapOrgVO[]) // 库存地点列表

const formData = ref({
  id: undefined,
  deptId: undefined,
  factoryId: undefined,
  factoryCode: undefined,
  factoryName: undefined,
  costCenterId: undefined,
  costCenterCode: undefined,
  storageLocationId: undefined,
  storageLocationCode: undefined,
  code: undefined,
  name: undefined,
  type: undefined,
  sort: undefined,
  status: undefined,
  remark: undefined,
})
const formRules = reactive<FormRules>({
  storageLocationId: [{ required: true, message: '库存地点不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '库区名称不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotStorageAreaApi.getIotStorageArea(id)
    } finally {
      formLoading.value = false
    }
  }
  // 加载库存地点(SAP)列表
  storageLocationList.value = await SapOrgApi.SapOrgApi.getSimpleSapOrgList(3)
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotStorageAreaVO
    if (formType.value === 'create') {
      await IotStorageAreaApi.createIotStorageArea(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotStorageAreaApi.updateIotStorageArea(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deptId: undefined,
    factoryId: undefined,
    factoryCode: undefined,
    factoryName: undefined,
    costCenterId: undefined,
    costCenterCode: undefined,
    storageLocationId: undefined,
    storageLocationCode: undefined,
    code: undefined,
    name: undefined,
    type: undefined,
    sort: undefined,
    status: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
